#ifdef _USE_WXWIDGETS_
#ifndef __bbcreaMaracasVisuPlaneDirection_h_INCLUDED__
#define __bbcreaMaracasVisuPlaneDirection_h_INCLUDED__
#include "bbcreaMaracasVisu_EXPORT.h"
#include "bbtkWxBlackBox.h"

#include <vtkRenderer.h>
#include <vtkImageData.h>

#include "PlaneDirectionViewer.h"

namespace bbcreaMaracasVisu
{

class bbcreaMaracasVisu_EXPORT PlaneDirection
 : 
   public bbtk::WxBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(PlaneDirection,bbtk::WxBlackBox);

  BBTK_DECLARE_INPUT(In,vtkImageData*);  
  BBTK_DECLARE_INPUT(Renderer, vtkRenderer* );
  BBTK_DECLARE_INPUT(Filename, std::string );
  BBTK_DECLARE_INPUT( lstPointsX, std::vector<int> );
  BBTK_DECLARE_INPUT( lstPointsY, std::vector<int> );
  BBTK_DECLARE_INPUT( lstPointsZ, std::vector<int> );
  BBTK_DECLARE_INPUT( ArrowSize, int );
  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow*);

private:
	PlaneDirectionViewer*  _planedir;
	int radio;
	double colour[3];
	int opacity;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(PlaneDirection,bbtk::WxBlackBox);
BBTK_NAME("PlaneDirection");
BBTK_AUTHOR("car-prie@uniandes.edu.co");
BBTK_DESCRIPTION("Given a list of points and grouping them in triplets, the box calculates the direction of the plane formed by the three points");
BBTK_CATEGORY("__CategoryBlackBox__");

BBTK_INPUT(PlaneDirection,In,"Image data to get the spacing, if not found set to 1 1 1",vtkImageData*,"");
BBTK_INPUT(PlaneDirection,Renderer,"Renderer",vtkRenderer*,"");
BBTK_INPUT(PlaneDirection,Filename,"Filename to save the points of the plane and the direction",std::string,"");

BBTK_INPUT(PlaneDirection , lstPointsX , " list of points X ", std::vector<int> ,"");
BBTK_INPUT(PlaneDirection , lstPointsY , " list of points Y ", std::vector<int> ,"");
BBTK_INPUT(PlaneDirection , lstPointsZ , " list of points Z ", std::vector<int> ,"");

BBTK_INPUT(PlaneDirection , ArrowSize , "Size of the arrow ", int ,"");

BBTK_END_DESCRIBE_BLACK_BOX(PlaneDirection);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuPlaneDirection_h_INCLUDED__
#endif // _USE_WXWIDGETS_

