#include "bbcreaMaracasVisuVolumeRendering.h"
#include "bbcreaMaracasVisuPackage.h"

#include "wxMaracasMultipleVolumeRendererView.h"

namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,VolumeRendering)
BBTK_BLACK_BOX_IMPLEMENTATION(VolumeRendering,bbtk::WxBlackBox);
void VolumeRendering::Process()
{
 
// THE MAIN PROCESSING METHOD BODY 
//   Here we simply set the input 'In' value to the output 'Out' 
//   And print out the output value 
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM : 
//    void bbSet{Input|Output}NAME(const TYPE&) 
//    const TYPE& bbGet{Input|Output}NAME() const  
//    Where : 
//    * NAME is the name of the input/output 
//      (the one provided in the attribute 'name' of the tag 'input') 
//    * TYPE is the C++ type of the input/output 
//      (the one provided in the attribute 'type' of the tag 'input') 
    wxMaracasMultipleVolumeRendererView* volview = (wxMaracasMultipleVolumeRendererView*)bbGetOutputWidget();
	vtkImageData* _img1 = bbGetInputIn1();
	vtkImageData* _img2 = bbGetInputIn2();
	vtkImageData* _img3 = bbGetInputIn3();
	vtkImageData* _img4 = bbGetInputIn4();
	vtkRenderer* renderer = bbGetInputRenderer();

	if(volview!=NULL){
		if(renderer!=NULL&&_currentrenderer != renderer){
			volview->setRenderer(renderer);			
			_currentrenderer = renderer;
		}
		if(_currentrenderer!=NULL){
			if(_img1 !=NULL){
			volview->addVolume(_img1, "INPUT 1");
			}
			if(_img2 !=NULL){
				volview->addVolume(_img2, "INPUT 2");
			}
			if(_img3 !=NULL){
				volview->addVolume(_img3, "INPUT 3");
			}
			if(_img4 !=NULL){
				volview->addVolume(_img4, "INPUT 4");
			}
		}		
	}  
}
void VolumeRendering::CreateWidget(wxWindow* parent)
{

	wxMaracasMultipleVolumeRendererView* volview = wxMaracasMultipleVolumeRendererView::getInstance(parent);
	bbSetOutputWidget(volview);

}
void VolumeRendering::bbUserSetDefaultValues()
{
 
//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX  
//    Here we initialize the input 'In' to 0 
   bbSetInputIn1(0); 
   bbSetInputIn2(0); 
   bbSetInputIn3(0); 
   bbSetInputIn4(0); 
   bbSetInputRenderer(0);  
  
}
void VolumeRendering::bbUserInitializeProcessing()
{ 
	_currentrenderer = NULL;
}
void VolumeRendering::bbUserFinalizeProcessing()
{
 
//  THE FINALIZATION METHOD BODY : 
//    Here does nothing  
//    but this is where you should desallocate the internal/output pointers  
//    if any 
  
}
}
// EO namespace bbcreaMaracasVisu


