#ifndef __bbcreaMaracasVisuImageChangeInformation_h_INCLUDED__
#define __bbcreaMaracasVisuImageChangeInformation_h_INCLUDED__
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkImageData.h"
#include "vtkImageChangeInformation.h"

namespace bbcreaMaracasVisu
{

class /*BBTK_EXPORT*/ ImageChangeInformation
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ImageChangeInformation,bbtk::AtomicBlackBox);
  BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();

private:
	    vtkImageChangeInformation	*mchange;

};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ImageChangeInformation,bbtk::AtomicBlackBox);
BBTK_NAME("ImageChangeInformation");
BBTK_AUTHOR("eduardo.davila [at] creatis.insa-lyon.fr");
BBTK_DESCRIPTION("vtkImageData change information. Translate extern to 0,0,0");
  BBTK_CATEGORY("filter");
  BBTK_INPUT(ImageChangeInformation,In,"Input image",vtkImageData*,"");
  BBTK_OUTPUT(ImageChangeInformation,Out,"Output image",vtkImageData*,"");
BBTK_END_DESCRIBE_BLACK_BOX(ImageChangeInformation);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuImageChangeInformation_h_INCLUDED__

