#include "bbmaracasvisuViewerNV.h"
#include "bbcreaMaracasVisuPackage.h"
namespace bbcreaMaracasVisu
{


BEGIN_EVENT_TABLE( bbwxMaracas_N_ViewersWidget, wxPanel )
	EVT_MENU( 12121, bbwxMaracas_N_ViewersWidget::OnRefreshView )
	EVT_MENU( 12122, bbwxMaracas_N_ViewersWidget::OnDClickLeft  )
END_EVENT_TABLE( );


//-------------------------------------------------------------
//-------------------------------------------------------------
//-------------------------------------------------------------

bbwxMaracas_N_ViewersWidget::bbwxMaracas_N_ViewersWidget(ViewerNV* box,
														 wxWindow *parent, 
														 vtkImageData* imagedata, 
														 std::vector<int> *nTypeView)
:wxMaracas_N_ViewersWidget(parent,imagedata,nTypeView)
{
	mbbViewerNV=box;
}

//-------------------------------------------------------------
bbwxMaracas_N_ViewersWidget::~bbwxMaracas_N_ViewersWidget()
{
}

//-------------------------------------------------------------
void bbwxMaracas_N_ViewersWidget::OnRefreshView(wxCommandEvent & event)
{
	
	mbbViewerNV->point.clear();

	mbbViewerNV->point.push_back( (int)GetX() );
	mbbViewerNV->point.push_back( (int)GetY() );
	mbbViewerNV->point.push_back( (int)GetZ() );
	mbbViewerNV->bbSetOutputPoint( mbbViewerNV->point );
	mbbViewerNV->bbSignalOutputModification(std::string("Point"));    

	wxMaracas_N_ViewersWidget::OnRefreshView(event);
}

//-------------------------------------------------------------
void bbwxMaracas_N_ViewersWidget::OnDClickLeft(wxCommandEvent & event)
{
	wxMaracas_N_ViewersWidget::OnDClickLeft(event);
	mbbViewerNV->bbSignalOutputModification(std::string("Point"));    
}

//-------------------------------------------------------------
//-------------------------------------------------------------
//-------------------------------------------------------------



BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,ViewerNV)
BBTK_BLACK_BOX_IMPLEMENTATION(ViewerNV,bbtk::WxBlackBox);
//-------------------------------------------------------------
void ViewerNV::Process()
{	

	vtkImageData* img = bbGetInputIn();
	std::vector<int> type = bbGetInputnTypeView();

//	std::cout<<"img "<<img<<std::endl;
//	std::cout<<"widget "<<mwxwidget<<std::endl;
	
	if(img != NULL && mwxwidget != NULL){// && !enter){
		
		if(!compareVectors(type, currenttype)){
			mwxwidget->SetType(&type);
			mwxwidget->UpdateLayout(img);			
		}else if (img != currentimg){		
			mwxwidget->SetImage(img);
			//mwxwidget->UpdateLayout(img);
		}		
		currenttype = type;
		currentimg = img;
		

		point.clear();
		point.push_back((int)mwxwidget->GetX());
		point.push_back((int)mwxwidget->GetY());
		point.push_back((int)mwxwidget->GetZ());
		bbSetOutputPoint(point);

	//    WxBlackBox::Process(); 
//		mwxwidget->SetImage(img );
		wxVtkBaseView *wvbv1 = mwxwidget->GetwxVtkBaseView(1);
		wxVtkBaseView *wvbv2 = mwxwidget->GetwxVtkBaseView(2);
		wxVtkBaseView *wvbv3 = mwxwidget->GetwxVtkBaseView(3);
		wxVtkBaseView *wvbv4 = mwxwidget->GetwxVtkBaseView(4);

		//wxwidget->RefreshView();

		bbSetOutputwxVtkBaseView1( wvbv1 );
		bbSetOutputwxVtkBaseView2( wvbv2 );
		bbSetOutputwxVtkBaseView3( wvbv3 );
		bbSetOutputwxVtkBaseView4( wvbv4 );
		if (wvbv1!=NULL) { bbSetOutputRenderer1( wvbv1->GetRenderer() ); }
		if (wvbv2!=NULL) { bbSetOutputRenderer2( wvbv2->GetRenderer() ); }
		if (wvbv3!=NULL) { bbSetOutputRenderer3( wvbv3->GetRenderer() ); }
		if (wvbv4!=NULL) { bbSetOutputRenderer4( wvbv4->GetRenderer() ); }

		if(bbGetInputColorFunction()!=NULL){
			mwxwidget->setColorTransferFunction(bbGetInputColorFunction());
		}
	}	
}

//-------------------------------------------------------------
void ViewerNV::CreateWidget(wxWindow* parent)
{

    bbtkDebugMessageInc("Core",9,"ViewerNV::CreateWidget()"<<std::endl);
	mwxwidget = new bbwxMaracas_N_ViewersWidget( this, parent );	
	bbtkDebugDecTab("Core",9);
    bbSetOutputWidget( mwxwidget );	

	
	//this->bbSignalOutputModification();
	//Process();
}

//-------------------------------------------------------------
void ViewerNV::bbUserSetDefaultValues()
{

		mwxwidget = NULL;
		bbSetInputIn(NULL);

		std::vector<int> vecNTypeViwer;
		vecNTypeViwer.push_back(5);
		vecNTypeViwer.push_back(0);
		vecNTypeViwer.push_back(1);
		vecNTypeViwer.push_back(3);
		bbSetInputnTypeView(vecNTypeViwer);


		bbSetOutputwxVtkBaseView1( NULL );
		bbSetOutputwxVtkBaseView2( NULL );
		bbSetOutputwxVtkBaseView3( NULL );
		bbSetOutputwxVtkBaseView4( NULL );
		bbSetOutputRenderer1( NULL );
		bbSetOutputRenderer2( NULL );
		bbSetOutputRenderer3( NULL );
		bbSetOutputRenderer4( NULL );
		bbSetInputColorFunction(NULL);
}

	//-----------------------------------------------------------------	
	void ViewerNV::bbUserInitializeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	void ViewerNV::bbUserFinalizeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	
	
	
bool ViewerNV::compareVectors(std::vector<int> type,std::vector<int> currenttype){

	bool ret = true;

	if(type.size()==currenttype.size()){
		for(int i = 0; i < (int)(type.size()) && ret; i++){
			if(type[i]!=currenttype[i]){
				ret = false;
			}
		}
	}else{
		ret=false;
	}
	return ret;


}

}
// EO namespace bbcreaMaracasVisu


