/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracas3DBrowser.cxx,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:54 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#include "wxMaracas3DBrowser.h"
//#include <Crtdbg.h>


wxMaracas3DBrowser::wxMaracas3DBrowser( wxWindow* parent, marInterface* mar, wxWindowID id , int id_toolbar_plans  )
    : wxPanel( parent, id, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL )
{
    _mar = mar;

    _3DSurf = new wxSurfaceWidget( this, -1 );
	_3DSurf->SetId_toolbar_plans(id_toolbar_plans);

    wxBoxSizer* szTop = new wxBoxSizer( wxVERTICAL );
    szTop->Add( _3DSurf, 1, wxEXPAND | wxALL, 0 );

    this->SetAutoLayout( true );
    this->SetSizer( szTop );

//    szTop->Fit( this );
    szTop->SetSizeHints( this );

}
//----------------------------------------------------------------------------
void wxMaracas3DBrowser::LoadData( ){
    _3DSurf->ShowMARACASData( _mar );
}
//----------------------------------------------------------------------------
int wxMaracas3DBrowser::GetIsovalue(){
	int result=0;
	if (_3DSurf!=NULL){
		result=_3DSurf->GetIsovalue();
	}
	return result;
}
//----------------------------------------------------------------------------
int wxMaracas3DBrowser::GetOpacity(){
	int result=0;
	if (_3DSurf!=NULL){
		result=_3DSurf->GetOpacity();
	}
	return result;
}
//----------------------------------------------------------------------------
void wxMaracas3DBrowser::RegenerateAll(bool all){
	if (_3DSurf!=NULL){
		_3DSurf->Clean3D();
		if (all==true){
			_mar->_experiment->RegenerateAxis();
		} else {
			_mar->_experiment->RecalculateAxis();
		}
		_3DSurf->AddAxisActors();	
		_3DSurf->RefreshAxis();	
	}
}
//----------------------------------------------------------------------------

// EOF - wxMaracas3DBrowser.cxx

