#ifndef FIGURECUTTINGMODEL_H_
#define FIGURECUTTINGMODEL_H_

#include "vtkTransform.h"

class figureCuttingModel
{
public:
	figureCuttingModel();
	virtual ~figureCuttingModel();

	void			SetPosition(double x,double y, double z);
	double			GetPositionX();
	double			GetPositionY();
	double			GetPositionZ();

	void			SetScale(double sx,double sy, double sz);
	double			GetScaleX();
	double			GetScaleY();
	double			GetScaleZ();

	void			SetRotation(double alfa,double beta, double teta);
	double			GetAngleAlfa();
	double			GetAngleBeta();
	double			GetAngleTeta();

	void			SetSpacing(double spcX,double spcY, double spcZ);

	void			CalculeMatrix();
	void			CalculeInversMatrix();
	virtual bool	IfPointInside(double x, double y, double z);
	vtkTransform	*GetVtkTransform();
//	void			SetVtkTransform(vtkTransform *matrix);
	virtual double	GetTheoricVolume();
	virtual			char *GetName();

private:
	double			_px;
	double			_py;
	double			_pz;
	double			_alfa;
	double			_beta;
	double			_teta;
	double			_spcX;
	double			_spcY;
	double			_spcZ;
protected:
	double			_sx;
	double			_sy;
	double			_sz;
	vtkTransform	*_inversModel;
	vtkTransform	*_matrixModel;
	vtkTransform	*_matrixVisual;

};

#endif /*FIGURECUTTINGMODEL_H_*/
