#ifndef __WX__IMAGE__BROWSER__WDG__
#define __WX__IMAGE__BROWSER__WDG__

#include <wx/wx.h>
#include <wx/image.h>
#include <wx/imaglist.h>
#include <wx/list.h>
#include <wx/scrolwin.h>

/**
 * \brief Widget class that shows thumbnails images
 */
class wxImageBrowserWdg : public wxScrolledWindow
{
public:
    wxImageBrowserWdg(
	wxWindow* parent,
	wxWindowID id = -1,
	int sx = 100,
	int sy = 100,
	int gap = 10,
	const wxPoint& pos = wxDefaultPosition,
	const wxSize& size = wxDefaultSize,
	long style = wxScrolledWindowStyle,
	const wxString& name = wxPanelNameStr
	);

    void SetVolume(
        unsigned short*** volume,
        wxArrayString& names,
        int width,
        int height,
        int depth,
        int min,
        int max
        );

    void SetScaleX( int sx );
    void SetScaleY( int sy );
    void SetGap( int gap );
    int GetScaleX( );
    int GetScaleY( );
    int GetGap( );

    int GetFirst( );
    int GetLast( );

    void GetSizeParameters( int* n, int* c, int* r );

    void OnDraw( wxDC& dc );
    void OnSize( wxSizeEvent& event );

    void OnMouseLeftClick( wxMouseEvent& event );
    void OnMouseRightClick( wxMouseEvent& event );

//    void Add( const wxImage& ima, const wxString& nrs );

private:

    int GetIndexClicked( wxMouseEvent& event );

    wxImageList _ima_list;
    wxArrayString _nrs_list;
    int _sx;
    int _sy;
    int _gap;
    int _first_selected;
    int _last_selected;

    DECLARE_EVENT_TABLE( );

};

#endif // __WX__IMAGE__BROWSER__WDG__
