/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxSegmentationFM3DWidget.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:57 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __WX__SEGMENTATION__FM3D__HXX__
#define __WX__SEGMENTATION__FM3D__HXX__

/*
#include <vector>

#include <vtkObjectBase.h>
#include <vtkCommand.h>
#include <vtkActor.h>
#include <vtkPoints.h>
#include <vtkPolyData.h>
#include <vtkPolyDataMapper.h>
#include <vtkProbeFilter.h>
#include <vtkPlaneSource.h> 
#include <vtkImageChangeInformation.h>
#include <vtkStructuredPoints.h> 
#include <vtkTransform.h> 
#include <vtkImageViewer2.h> 
#include <vtkBoxWidget.h>
*/
	     
/*
#include "kernel/marInterface.h"

#include "wxMPRBaseData.h"
#include "wxVtkBaseView.h"
*/


#include <wx/notebook.h>

#include "vtkImageGaussianSmooth.h"
#include "vtkSmoothPolyDataFilter.h"

#include "wxMPRWidget.h"
#include "../manualContour.h"

#include "itkFM3D.h"


//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------


class wxSegmentationFM3DWidget : public wxPanel
{
public:
    wxSegmentationFM3DWidget(wxWindow* parent,marImageData *marimageData,double voxelSize);
	~wxSegmentationFM3DWidget( );

	void ConfigureVTK();

	void RefreshView();
	void OnRefreshView(wxCommandEvent & event);


	vtkMPRBaseData		*GetVtkMPRBaseData();
	vtkPlane2DView		*GetVtkPlane2DView();



private:
	double								_voxelSize;
	marImageData						*_marimageData; 
	wxMPRWidget2						*_MPRWidget2;

	//
	wxVtk3DBaseView						*_wxvtk3Dbaseview_Clipping3D_C;
	wxVtkMPR3DView						*_wxvtkmpr3Dview_C;
	wxVtkClipping3DView					*_wxvtkclipping3Dview_C;

	wxPanel		*Create3DViewContour( wxWindow *parent, vtkMPRBaseData *vtkmprbasedata);
	void		ConfigureContour();

	//DCH: CONTROLES INTERFAZ GRAFICA

	wxSlider* slAlpha;
	wxSlider* slBeta;
	wxButton* btnSegment;
	wxButton* btnUndo;
	wxSlider* slVolumeOpacity;
	wxSlider* slSigmaLevel;
	wxSlider* slLaplacianConvergence;
	wxSlider* slLaplacianIterations;


	void OnChangeAlpha(wxScrollEvent& event);
	void OnChangeBeta(wxScrollEvent& event);
	void OnBtnSegment(wxCommandEvent& event);
	void OnBtnUndo(wxCommandEvent& event);
	void OnChangeOpacity(wxScrollEvent& event);
	void OnChangeSigmaLevel(wxScrollEvent& event);
	void OnChangeLaplacianConvergence(wxScrollEvent& event);
	void OnChangeLaplacianIteration(wxScrollEvent& event);


	// DHC: MODELO
	itkFM3D* filtroSegmentacion;
	double alphaValue;
	double betaValue;
	double opacityValue;
	double sigmaValue;
	float convergenceValue;
	int	   iterationsValue;

	// DHC: RENDERIZACION VTK
	vtkImageGaussianSmooth*		f_gauss;
	vtkMarchingCubes*			f_cubes;
	vtkSmoothPolyDataFilter*	f_laplace;
	vtkPolyDataMapper*			f_mapper;
	vtkActor*					f_actor;



	DECLARE_EVENT_TABLE( );



};




#endif // __WX__SEGMENTATION__FM3D__HXX__ 

// EOF - wxSegmentationFM3DWidget.h
