#include "manualCircleControler.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// EED08

// _state = 0  // ..nothing..
// _state = 5  // move point
// _state = 6  // move all
// _state = 7  // Empty mouse drag

manualCircleControler::manualCircleControler()
{
}
// ----------------------------------------------------------------------------
manualCircleControler::~manualCircleControler()
{
}
// ----------------------------------------------------------------------------
manualCircleControler * manualCircleControler :: Clone()  // virtual
{
	manualCircleControler * clone = new manualCircleControler();
	CopyAttributesTo(clone);
	return clone;
}

// ---------------------------------------------------------------------------
void manualCircleControler::CopyAttributesTo( manualCircleControler * cloneObject)
{
	// Fathers object
	manualContourBaseControler::CopyAttributesTo(cloneObject);
}

// ----------------------------------------------------------------------------
void manualCircleControler::Configure() //virtual
{
//	this->GetManualContourModel()->SetNumberOfPointsSpline(5);
}

// ----------------------------------------------------------------------------
void manualCircleControler::MouseClickLeft(int x, int y){
	int z = GetZ();
	
	if( IsEditable() )
	{	// move control point
  	  if ( (GetState()==0) && (GetManualViewBaseContour()->GetIdPoint(x,y,z)!=-1 ) ){
  		  bakIdPoint = GetManualViewBaseContour()->GetIdPoint(x,y,z);
		  SetState(5);
	  }
	}// IsEditable
	
	// move contour
	if ((GetState()==0) && (GetManualViewBaseContour()->GetPosibleSelected()==true))	{
		GetManualViewBaseContour()->InitMove(x,y,z);
		SetState(6);
	}
	
	// firstime create 2 control points and move one control point
	int size=GetManualViewBaseContour()->GetNumberOfPoints();
	if (GetState()==0) {
		if (size==0){
			AddPoint(x,y,z);
			AddPoint(x,y,z);
			bakIdPoint = GetManualViewBaseContour()->GetIdPoint(x,y,z);
			SetState(1);
		}
	}	
	
/*EED 21 Avril 2009	
	if (GetState()==0) {
		if (size==0){
			AddPoint(x,y,z);
			AddPoint(x,y,z);
		} else {
			SetPoint(0,x,y,z);
			SetPoint(1,x,y,z);
		}
		bakIdPoint = GetManualViewBaseContour()->GetIdPoint(x,y,z);
		SetState(5);
	}
*/
	
	GetManualViewBaseContour()->Refresh();
}
// ----------------------------------------------------------------------------

void manualCircleControler::MouseMove(int x, int y) // virtual
{
	int z=GetZ();
//	this->_vtkInteractorStyleBaseView->

	GetManualViewBaseContour()->SelectPosibleContour(x,y,z);
	GetManualViewBaseContour()->SelectPosiblePoint(x,y,z);

	if (GetState()==1){	SetPoint( bakIdPoint , x , y ,z); }
	if (GetState()==5){	SetPoint( bakIdPoint , x , y ,z); }
	
	if (GetState()==6){
		GetManualViewBaseContour()->MoveContour(x,y,z);
	}
	GetManualViewBaseContour()->Refresh();
}


// ----------------------------------------------------------------------------
void manualCircleControler::DeleteActualMousePoint(int x, int y)  // virtual
{
}
// ----------------------------------------------------------------------------

void manualCircleControler::InitRoi(int ww, int hh, double porcentage)
{
	int zz;
	manualPoint *mp;

	if (GetManualContourModel()->GetSizeLstPoints() ==0)
	{
		zz = GetZ();
		AddPoint(0,0,zz);
		AddPoint(0,0,zz);
//		AddPoint(0,0,zz);
//		AddPoint(0,0,zz);
	}

	double pp1=porcentage;
	double pp2=1-porcentage;

//	mp = GetManualContourModel()->GetManualPoint(2);
//	zz=(int)mp->GetZ();
//	mp->SetPoint(ww*pp1,hh*pp1,zz);

	mp = GetManualContourModel()->GetManualPoint(1);
	zz=(int)mp->GetZ();
	mp->SetPoint(ww*pp2,hh*pp1,zz);

	mp = GetManualContourModel()->GetManualPoint(0);
	zz=(int)mp->GetZ();
	mp->SetPoint(ww*pp2,hh*pp2,zz);

//	mp = GetManualContourModel()->GetManualPoint(3);
//	zz=(int)mp->GetZ();
//	mp->SetPoint(ww*pp1,hh*pp2,zz);

	GetManualViewBaseContour() ->UpdateViewPoint(0);
	GetManualViewBaseContour() ->UpdateViewPoint(1);
//	GetManualViewBaseContour() ->UpdateViewPoint(2);
//	GetManualViewBaseContour() ->UpdateViewPoint(3);

	SetState(0);
	GetManualViewBaseContour()->Refresh();
}

// ----------------------------------------------------------------------------
/*
void manualCircleControler::SetRoi(int x1, int y1,int x2, int y2)
{
	manualPoint *mp;
	InitRoi( 0 , 0 , 0.2 );
	mp = GetManualContourModel()->GetManualPoint(2);
	mp->SetPointX(x1);
	mp->SetPointY(y1);

	mp = GetManualContourModel()->GetManualPoint(1);
	mp->SetPointX(x2);
	mp->SetPointY(y1);

	mp = GetManualContourModel()->GetManualPoint(0);
	mp->SetPointX(x2);
	mp->SetPointY(y2);

	mp = GetManualContourModel()->GetManualPoint(3);
	mp->SetPointX(x1);
	mp->SetPointY(y2);

	GetManualViewBaseContour() ->UpdateViewPoint(0);
	GetManualViewBaseContour() ->UpdateViewPoint(1);
	GetManualViewBaseContour() ->UpdateViewPoint(2);
	GetManualViewBaseContour() ->UpdateViewPoint(3);
}
*/
