#ifndef manualContourModelBullEye_h
#define manualContourModelBullEye_h

#include "manualContourModel.h"
#include "manualContourModelBullEyeSector.h"

//--------------------------------------------------------
//eed004
class creaMaracasVisu_EXPORT manualContourModelBullEye : public manualContourModel
{
public:
	manualContourModelBullEye();
	virtual ~manualContourModelBullEye();
	virtual manualContourModelBullEye *Clone();
	void	CopyAttributesTo( manualContourModelBullEye *cloneObject);
	virtual void Save(FILE *ff);
	virtual void Open(FILE *ff);

	int		GetNumberOfPointsSplineSectorBulleEje();
	void	SetNumberOfPointsSplineSectorBulleEje(int);
	void	AddSector(	double radioA,
						double radioB,
						double ang,
						double angDelta);
	void GetSector(		int id,	
						double *radioA,
						double *radioB,
						double *ang,
						double *angDelta);
	manualContourModelBullEyeSector * GetModelSector(int id);

	void	ResetSectors();
	int		GetSizeOfSectorLst();
	virtual void UpdateSpline(); // virtual
	virtual std::vector<manualContourModel*> ExploseModel(  );



private:
	int											   _numberPointsSlineBySector;
	std::vector<manualContourModelBullEyeSector *> _lstModelBullEyeSector;

/* Borrame Eduardo
	std::vector<double>		_lstRadioA;
	std::vector<double>		_lstRadioB;
	std::vector<double>		_lstAng;
	std::vector<double>		_lstAngDelta;
*/

	virtual int		GetTypeModel();  
};

#endif // manualContourModelBullEye_h
