#ifndef manualContourPerpPlaneControler_h
#define manualContourPerpPlaneControler_h

#include "manualContourControler.h"
#include "manualContour3VControler.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

class creaMaracasVisu_EXPORT manualContourPerpPlaneControler: public manualContourControler
{
public:
	manualContourPerpPlaneControler();
	virtual ~manualContourPerpPlaneControler();
    virtual manualContourPerpPlaneControler * Clone();
	void CopyAttributesTo( manualContourPerpPlaneControler *cloneObject );

	void SetVtkMPRBaseData(vtkMPRBaseData *vtkmprbasedata);
	vtkMPRBaseData *GetVtkMPRBaseData();

	virtual bool OnChar();
	virtual bool OnMouseMove();
	virtual bool OnLeftDClick(); 
	virtual void AddPoint( int x, int y, int z );
	virtual void DeleteActualMousePoint(int x, int y);
	virtual void MouseMove(int x, int y);
	virtual void InsertPoint(int x, int y, int z);
	virtual void ResetContour();

			void SetManualContour3VControler(manualContour3VControler *manualcontour3Vcontroler);
			manualContour3VControler *GetManualContour3VControler();

	virtual void MouseDLeft( int x, int y);
			void ResetOrientationPlane();
			void SetVtkInteractorStylePlane2D(InteractorStyleMaracas *vtkinteractorstyleplane2D);
			InteractorStyleMaracas * GetVtkInteractorStylePlane2D();

private:
	bool						_flagMouseMove;
	bool						_flagMouseDClick;
	InteractorStyleMaracas		*_vtkinteractorstyleplane2D;

protected:
	vtkMPRBaseData				*_vtkmprbasedata;
	manualContour3VControler	*_manualcontour3Vcontroler;
};


#endif // manualContourPerpPlaneControler_h
