#include "manualView3VContour.h"


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

manualView3VContour::manualView3VContour(int type)
{
	_type=type;
// JSTG 25-02-08 ------------------------------
	//_manContModel= new manualContourModel();
//---------------------------------------------
}
// ----------------------------------------------------------------------------
manualView3VContour::~manualView3VContour()
{
}



// ----------------------------------------------------------------------------
manualView3VContour * manualView3VContour :: Clone()
{
	manualView3VContour * clone = new manualView3VContour( GetType() );
	CopyAttributesTo(clone);
	return clone;
}

// ---------------------------------------------------------------------------

void manualView3VContour::CopyAttributesTo( manualView3VContour * cloneObject)
{
	// Fathers object
	manualViewContour::CopyAttributesTo(cloneObject);
}

int manualView3VContour::GetType()
{
	return _type;
}

// ----------------------------------------------------------------------------
void manualView3VContour::FilterCordinateXYZ(double &x,double &y,double &z)
{
	if (_type==0)
	{
		x=-1000;
	}
	if (_type==1)
	{
		y=500;
	}
	if (_type==2)
	{
		z=-1000;
	}
}
// ----------------------------------------------------------------------------

void manualView3VContour::RefreshContour()  // virtula
{
	manualViewContour::RefreshContour();
	int i;
	double pp[3];
// JSTG 25-02-08 ----------------------------------------
	//int nps = GetNumberOfPointsSpline();
	int nps = _manContModel->GetNumberOfPointsSpline();
//-------------------------------------------------------
	for( i = 0; i < nps; i++ )
	{
		_pts->GetPoint( i, pp );
		FilterCordinateXYZ(pp[0],pp[1],pp[2]);

//EED 27 sep 2006
		_pts->SetPoint( i, pp[0] , pp[1] ,pp[2] );
	}

}

// ----------------------------------------------------------------------------

void manualView3VContour::UpdateViewPoint(int id){  // virtual
	double x,y,z;
	manualPoint		*mp		= _manContModel->GetManualPoint(id);
	x=mp->GetX();
	y=mp->GetY();
	z=mp->GetZ();

	FilterCordinateXYZ(x,y,z);
	_lstViewPoints[id]->SetPositionXY( x , y ,GetRange(), z );
}

// ----------------------------------------------------------------------------

int	manualView3VContour::GetIdPoint(int x, int y, int z) // virtual
{
	int ii=-1;
	if (_manContModel!=NULL){
		double xx=x;
		double yy=y;
		double zz=z;
		TransfromCoordViewWorld(xx,yy,zz,-1);
		ii=_manContModel->GetIdPoint(xx,yy,zz,GetRange(),_type);
	}
	return ii;
}

// ----------------------------------------------------------------------------
bool manualView3VContour::ifTouchContour(int x,int y,int z){ // virtual
	bool result=false;
	double xx=x;
	double yy=y;
	double zz=z;
	double ppA[3];
	double ppB[3];
	double d1,d2,d3;
	TransfromCoordViewWorld(xx,yy,zz,-1);

//EED 27 sep 2006
	xx = xx * _spc[0];
	yy = yy * _spc[1];
	zz = zz * _spc[2];

    unsigned int i, nps,nps_t;
    nps	  = _sizePointsContour;
	if (this->_manContModel->IfCloseContour()==true)
	{
		nps_t = nps;
	} else {
		nps_t = nps-1;
	}
	FilterCordinateXYZ(xx,yy,zz);

    for( i = 0; i < nps_t; i++ ) {
		_pts->GetPoint(i%nps, ppA);
		_pts->GetPoint((i+1)%nps, ppB);
		FilterCordinateXYZ(ppA[0],ppA[1],ppA[2]);
		FilterCordinateXYZ(ppB[0],ppB[1],ppB[2]);
		d1= sqrt( (ppA[0]-xx)*(ppA[0]-xx) + (ppA[1]-yy)*(ppA[1]-yy) + (ppA[2]-zz)*(ppA[2]-zz));
		d2= sqrt( (ppB[0]-xx)*(ppB[0]-xx) + (ppB[1]-yy)*(ppB[1]-yy) + (ppB[2]-zz)*(ppB[2]-zz));
		d3= sqrt( (ppB[0]-ppA[0])*(ppB[0]-ppA[0]) + (ppB[1]-ppA[1])*(ppB[1]-ppA[1]) + (ppB[2]-ppA[2])*(ppB[2]-ppA[2]));
		if (  ((d1+d2)>=d3) &&  ((d1+d2)<=d3*1.3) ) {
			result=true;
			i=nps;
		}
	}
	return result;
}
