#ifndef manualViewContour_h
#define manualViewContour_h

#include "manualContourModel.h"
#include "manualViewBaseContour.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

class creaMaracasVisu_EXPORT manualViewContour: public manualViewBaseContour
{
public:
	manualViewContour();
	virtual ~manualViewContour();
	virtual manualViewContour * Clone();
	void CopyAttributesTo( manualViewContour *cloneObject );

	virtual int GetType();
	virtual void Save(FILE *pFile);
	virtual void Open(FILE *pFile);


	virtual void RefreshContour();
	virtual bool ifTouchContour(int x,int y, int z);
	virtual void InitMove(int x, int y, int z);
	virtual void MoveContour(int x, int y, int z);	
	virtual void MoveContour(int horizontalUnits, int verticalUnits );
	virtual void DeletePoint(int id); 
	virtual void ClearPoint(int id);
			void SetMesureScale(double mesureScale);
private:
	double	_mesureScale;
	std::vector< std::vector<double> > _initialMovingPoints;
	manualContourModel * _initialConoturModel;

	virtual void	RefreshText();
protected:

};

#endif // manualViewContour_h
