#ifndef manualViewPoint_h
#define manualViewPoint_h

#include "vtkRenderWindow.h"

#include "vtkRenderer.h"
#include "vtkRenderWindowInteractor.h" //extremely important with VC++ don't remove !
#include "vtkCommand.h"
#include "vtkPolyData.h"
#include "vtkCellArray.h"
#include "vtkPolyDataMapper.h"
#include "vtkInteractorObserver.h"
#include "vtkInteractorStyleImage.h"
#include <vtkKochanekSpline.h> 

#include <vtkCellPicker.h> 


#include <vtkCamera.h> 
#include <vtkPolyLine.h>
#include <vtkDataSetMapper.h>
#include <vtkUnstructuredGrid.h>

#include "wxVTKRenderWindowInteractor.h"


//--

#include <vector>
#include "wxVtkBaseView.h"
#include "marTypes.h"

//--------------------------------------------------------

class manualViewPoint{
public:

//	static int range;

	manualViewPoint(wxVtkBaseView *wxvtkbaseview);
	~manualViewPoint();
	void		SetSelected(bool selected);
	void		SetPosibleSelected(bool posibleSelected);
	bool		GetSelected();
	bool		GetPosibleSelected();
	void		DeleteVtkObjects();
	vtkActor*	CreateVtkPointActor();
	void		SetPositionXY(double x, double y, double range, double posZ);
	vtkActor*   GetVtkActor();
	void		UpdateColorActor();	
	void		GetSpacing(double spc[3]);
	void		SetSpacing(double spc[3]);
	void		SetWidthLine( double width);


private:
	bool				_selected;	
	bool				_posibleSelected;
	vtkPoints			*_pts;
	vtkPolyData			*_pd;
	vtkActor			*_pointVtkActor;
	vtkPolyDataMapper	*_bboxMapper;
	wxVtkBaseView		*_wxvtkbaseview;
	double				_widthline;
protected:
	double				_spc[3];
};

#endif // manualViewPoint_h
