#ifndef __LOGICAL_COLOR_BAR__
#define __LOGICAL_COLOR_BAR__

// -----------------------------------------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// -----------------------------------------------------------------------------------------------------------
#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------

#include <vector>
#include <math.h>
#include <iostream>
#include <string>
#include <deque>
#include <vector>

#include "pColorPoint.h"

/** file LogicalColorBar.h */
class LogicalColorBar {

public:

	//------------------------------------------------------------------------------------------------------------
	// Constructors & Destructors
	//------------------------------------------------------------------------------------------------------------

	LogicalColorBar ();

	~LogicalColorBar();

	//------------------------------------------------------------------------------------------------------------
	// Methods
	//------------------------------------------------------------------------------------------------------------

	/*
	* Gets the first point
	*/
	pColorPoint * getFirstPoint();

	/*
	* Gets the last point
	*/
	pColorPoint * getLastPoint();

	double getMinValue();

	void  setMinValue(double valueMin);

	double getMaxValue();

	void setMaxValue(double valueMax);

	bool getOrientation();

	void setOrientation(bool orientation);

	bool addColorPoint(double xRealValue, wxColour theColour);

	bool deleteColorPoint ( double  valErase );

	//void getListIndexRangeLimits( int &startIndex, int &endIndex, int startSearched, int endSearched );
	
	void getPointersToRangeLimits( std::deque<pColorPoint *> &theInputQueue, int &startIndex, int &endIndex, int startSearched, int endSearched );

	pColorPoint * getLastAddedPoint();

	pColorPoint * getPointAtIndex(int anIndex);

	int getCount();

	void getDataAt(int index, double &x,int &red,int &green,int &blue);

	void clearPoints();

	double getMinAddedValue();

	double getMaxAddedValue();

	void changeColor(double pointValue, wxColour theNewColor);

	bool setColorPoints (std::vector<pColorPoint *> pointsVector);
//	
//private: 

	bool bar_orientation;

	//wxList	logicColorPoints;
	std::vector<pColorPoint * > logicColorPoints;

	pColorPoint * lastAddedPoint;

	double minValue;

	double maxValue;

	//DECLARE_CLASS(LogicalColorBar)
};	
#endif 



