#ifndef __pColorPoint_h__
#define __pColorPoint_h__

//------------------------------------------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
//------------------------------------------------------------------------------------------------------------

#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

//------------------------------------------------------------------------------------------------------------
// Class definition
//------------------------------------------------------------------------------------------------------------

class pColorPoint : public wxObject {

public:
	//------------------------------------------------------------------------------------------------------------
	// Constructors and destructors
	//------------------------------------------------------------------------------------------------------------

	/**
	* Create a point of the function.
	* @param x The x real value
	* @param _color The asigned colour 
	* @param isTemp The temporal o fixed asignation to the color
	*/
	pColorPoint(double  x , wxColour  col, bool isTemp);

	~pColorPoint();

	//------------------------------------------------------------------------------------------------------------
	// Methods definition
	//------------------------------------------------------------------------------------------------------------

	/*
	* Returns the x-value of the point
	* @retval realX
	*/
	double getRealX ();
	/**
	* Returns the colour of the point
	* @retval colour
	*/
	wxColor getColor ();
	/**
	* Sets the x-value of the point
	* @param x
	*/
	void setRealX(double x)
	{
		realX = x;
	}
	/**
	* Sets the  colour of the point
	* @param _col
	*/	
	void setColor(wxColour _col)
	{
		colour = _col;
	}

	/**
	* Indicates if the colour point is temporal or not
	* @retval isTemporal
	*/
	bool isTemporalColor ();
	
	//------------------------------------------------------------------------------------------------------------
	// Attributes declration
	//------------------------------------------------------------------------------------------------------------

private:
	/*
	* The x-value of the point
	*/
	double realX;
	/*
	* The colour of the point
	*/          
	wxColour colour;
	/*
	* Represents the attibute of being temporal or not
	*/
	bool isTemporal;
	
	DECLARE_CLASS (pColorPoint)
};

#endif


