
#include "vtkBaseData.h"

vtkBaseData::vtkBaseData()
{

	_z            = 0;
	_t            = 0;
	_marImageData = NULL;
}

//-------------------------------------------------------------------
vtkBaseData::~vtkBaseData()
{
}

//-------------------------------------------------------------------
void vtkBaseData::SetMarImageData(marImageData *marimagedata)
{
	_marImageData = marimagedata;
	//Configure();
}

//-------------------------------------------------------------------
vtkImageData* vtkBaseData::GetImageData()
{
	return _marImageData->GetImageDataT(_t);
}
//-------------------------------------------------------------------
marImageData* vtkBaseData::GetMarImageData()
{
	return _marImageData;
}

//-------------------------------------------------------------------

void vtkBaseData::Configure()  // virtual
{
}

//-------------------------------------------------------------------
void vtkBaseData::SetZ(double z){
	//int maxZ;

//	int dim[3];
//	_marImageData->GetDimensions(dim);
//	maxZ=dim[2];

	int ext[6];
	vtkImageData* img = _marImageData->GetImageData();
	if(img!=NULL){
		/*img->GetWholeExtent(ext);
		maxZ=ext[5]-ext[4]+1;

		if (z>=maxZ)
		{
			//z=maxZ-1;
		}
		if (z<=0)
		{
			z=0;
		}

		_z=z;*/
		img->GetExtent(ext);
		if (z > ext[5])
		{
			z = ext[5];
		}
		if (z < ext[4])
		{
			z = ext[4];
		}

		_z=z;
	}
}
//-------------------------------------------------------------------
double vtkBaseData::GetZ()
{
	return _z;
}
//-------------------------------------------------------------------
int vtkBaseData::GetT()
{
	return _t;
}
//-------------------------------------------------------------------
void vtkBaseData::SetT(double t)
{
	int maxT = _marImageData->GetMaxT();
	if (t>=maxT)
	{
		t=maxT-1;
	}
	if (t<=0)
	{
		t=0;
	}
	_t=(int)t;
}

