
#include "vtkInteractorStyleSphere.h"

#include "wxSphereView.h"

vtkInteractorStyleSphere::vtkInteractorStyleSphere()
{
	_stateRadio  = false;
	_stateRotate = false;
}

//---------------------------------------------------------------------------

vtkInteractorStyleSphere::~vtkInteractorStyleSphere()
{
}


//---------------------------------------------------------------------------

bool  vtkInteractorStyleSphere::OnRightButtonDown()
{
	if ((_vtkInteractorStyleBaseView->GetInteractor()->GetControlKey()==0) && (_vtkInteractorStyleBaseView->GetInteractor()->GetShiftKey()==0) )
	{
		_stateRadio	= true;
		//_fordwareX	= this->Interactor->GetEventPosition()[0];
		_fordwareY	= _vtkInteractorStyleBaseView->GetInteractor()->GetEventPosition()[1];

		wxSphereView *wxsphereview = (wxSphereView*)(_vtkInteractorStyleBaseView->GetWxVtk2DBaseView());

		_radio = wxsphereview->GetRadio();
	}

	return true;
}

//---------------------------------------------------------------------------

bool  vtkInteractorStyleSphere::OnRightButtonUp() 
{
	if (_stateRadio==true)
	{
		wxSphereView *wxsphereview = (wxSphereView*)(_vtkInteractorStyleBaseView->GetWxVtk2DBaseView());
		wxsphereview->SetDeltaVoxel(1);
		double radio=wxsphereview->GetRadio();
		wxsphereview->GetIdOfImage(radio+0.1);
		wxsphereview->GetIdOfImage(radio+0.2);
		wxsphereview->GetIdOfImage(radio-0.1);
		wxsphereview->GetIdOfImage(radio-0.2);

		wxsphereview->RefreshView();
		_stateRadio = false;
	}

	return true;
}
//---------------------------------------------------------------------------

bool vtkInteractorStyleSphere::OnLeftButtonDown()
{
	_stateRotate	= true;
	_fordwareX		= _vtkInteractorStyleBaseView->GetInteractor()->GetEventPosition()[0];
	_fordwareY		= _vtkInteractorStyleBaseView->GetInteractor()->GetEventPosition()[1];
	return true;
}


//---------------------------------------------------------------------------

bool  vtkInteractorStyleSphere::OnLeftButtonUp() 
{
	wxSphereView *wxsphereview = (wxSphereView*)(_vtkInteractorStyleBaseView->GetWxVtk2DBaseView());
	if (_stateRotate==true){
		int fx	= _vtkInteractorStyleBaseView->GetInteractor()->GetEventPosition()[0];
		int fy	= _vtkInteractorStyleBaseView->GetInteractor()->GetEventPosition()[1];

		if ((_fordwareX==fx)&&(_fordwareY==fy)){
			double x=fx,y=fy,z=1;
			_vtkInteractorStyleBaseView->TransformCoordinate(x,y,z);	    
			wxsphereview->SetXYZtoParent(x,y);
			wxCommandEvent newevent(wxEVT_COMMAND_MENU_SELECTED,12121);
			wxsphereview->GetWxVTKRenderWindowInteractor()->GetParent()->ProcessEvent(newevent);
		} else {
			wxsphereview->RotationEnd();
		}
		wxsphereview->RefreshView();
		_stateRotate = false;
	}

	return true;
}


//---------------------------------------------------------------------------

bool  vtkInteractorStyleSphere::OnMouseMove () 
{
	wxSphereView *wxsphereview = (wxSphereView*)(_vtkInteractorStyleBaseView->GetWxVtk2DBaseView());
	if (_stateRotate==true)
	{
		bool ok_v, ok_ang;
		ok_v=false;
		ok_ang=false;
		if (_vtkInteractorStyleBaseView->GetInteractor()->GetControlKey()==1)
		{
			ok_v = true;
		}
		if (_vtkInteractorStyleBaseView->GetInteractor()->GetShiftKey()==1)
		{
			ok_ang = true;
		}
	    int fx = _vtkInteractorStyleBaseView->GetInteractor()->GetEventPosition()[0];
        int fy = _vtkInteractorStyleBaseView->GetInteractor()->GetEventPosition()[1];
		wxsphereview->RotationStart( fx - _fordwareX , -(fy - _fordwareY) , ok_v, ok_ang);
		wxsphereview->RefreshView();
	} 
	if (_stateRadio==true)
	{	    
		//int fx = this->Interactor->GetEventPosition()[0];
        int fy = _vtkInteractorStyleBaseView->GetInteractor()->GetEventPosition()[1];
		double dif=(fy-_fordwareY) / 10.0;
		wxsphereview->SetRadio( _radio + dif );
		wxsphereview->SetDeltaVoxel(3);
		wxsphereview->RefreshView();
	}

	return true;
}
