#ifndef VTKMPR3DDATAVIEWER_H_
#define VTKMPR3DDATAVIEWER_H_

#include "wxMPRBaseData.h"
#include "vtkProperty.h"
#include <vtkImageMapToColors.h> 
#include "vtkOutlineFilter.h"
#include "vtkPolyDataMapper.h"
#include "vtkActor.h"
#include <vtkColorTransferFunction.h>
#include "vtkImageActor.h"

class creaMaracasVisu_EXPORT vtkMPR3DDataViewer {
public:
	vtkMPR3DDataViewer();
	virtual ~vtkMPR3DDataViewer();
	vtkImageActor*			GetImageActor(int id);
	vtkActor*				GetOutlineActor();
	virtual void			Refresh();
	virtual void			Configure();
	void					SetVisiblePosition(int idPosition, bool visible);
	bool					GetVisiblePosition(int idPosition);
	vtkImageActor*			GetvtkActor_saggital();
	vtkImageActor*			GetvtkActor_axial();
	vtkImageActor*			GetvtkActor_coronal();
	void					SetPositionX(int pos);
	void					SetPositionY(int pos);
	void					SetPositionZ(int pos);
	void					SetVtkMPRBaseData(vtkMPRBaseData *vtkmprbasedata);
	vtkMPRBaseData*			GetVtkMPRBaseData();
	
	vtkColorTransferFunction   *GetvtkColorTransferFunction();
	std::vector<double >	   *GetctFunVectorPoint();
	std::vector<double >	   *GetctFunVectorRed();
	std::vector<double >	   *GetctFunVectorGreen();
	std::vector<double >	   *GetctFunVectorBlue();

private:
	
	bool								_visiblePosition[3];

	// outline
	vtkOutlineFilter					*_outlineData;
	vtkPolyDataMapper					*_mapOutline;
	vtkActor							*_outline;

	//
	vtkColorTransferFunction			*_ctfun;
	std::vector<double>					_ctFunVectorPoint;
	std::vector<double>					_ctFunVectorRed;
	std::vector<double>					_ctFunVectorGreen;
	std::vector<double>					_ctFunVectorBlue;

//	vtkLookupTable						*_bwLut;
//	vtkLookupTable						*_hueLut;
//	vtkLookupTable						*_satLut;

	vtkImageMapToColors					*_saggitalColors;
	vtkImageActor						*_saggital;
	vtkImageMapToColors					*_axialColors;
	vtkImageActor						*_axial;
	vtkImageMapToColors					*_coronalColors;
	vtkImageActor						*_coronal;
	vtkMPRBaseData						*_vtkmprbasedata;


};

#endif /*VTKMPR3DDATAVIEWER_H_*/
