/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasIRMView.h,v $
  Language:  C++
  Date:      $Date: 2009/06/16 13:25:58 $
  Version:   $Revision: 1.6 $

  Copyright: (c) 2002, 2003
  License:

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __wxMaracasIRMViewPanelH__
#define __wxMaracasIRMViewPanelH__

#include <vector>
#include <wx/wx.h>
#include "wx/aui/aui.h"
#include <iostream>
#include "marTypes.h"
#include "vtkProp3D.h"

#include "wxMaracasIRMViewManager.h"
#include "wxMaracasIRMViewPanel.h"



class  creaMaracasVisu_EXPORT  wxMaracasIRMView : public wxPanel
{

public:
	wxMaracasIRMView( wxWindow* parent, std::string path);
    ~wxMaracasIRMView( );

	static wxMaracasIRMView* getInstance(wxWindow* parent,std::string path="");

	static wxMaracasIRMView* getInstance();

	void setRenderer(vtkRenderer*  renderer);

	void changeOpacity(int propid, int value);

	void changeIsoValue(int propid, double value);

    void addRemoveActor(int propid, bool addremove);

	void changeColor(int propid, double red, double green, double blue);

	void addProp3D(vtkProp3D* prop3D, std::string dataname="");

	void addPropMHD(vtkImageData* imgdata, std::string dataname="");

	void loadProp3D(wxString filename, wxString dataname);

	void loadPropMHD(wxString filename, wxString dataname);

	void onLoadImageFile();

	void addIRMViewPanel(wxMaracasIRMViewPanel* irmview, std::string dataname="");

	std::string getPath();

	void deleteActor(int propid);
private:
	static wxMaracasIRMView* instance;

	wxMaracasIRMViewManager* irmmanager;

	wxAuiManager* wxauimanager;

	void createFileChooser();

	std::string _path;

	wxToolBar* _toolb;

};

class ToolBarEventHandler : public wxEvtHandler{

	public:
		ToolBarEventHandler();
		~ToolBarEventHandler();

		void onLoadImageFile(wxCommandEvent& event);

	private:

		DECLARE_EVENT_TABLE()
	};

class ToolBar : public wxToolBar{

	
public:
	ToolBar(wxWindow * parent,std::string iconsdir);
	~ToolBar(void);


private:

	ToolBarEventHandler* _evthand;

};

#endif

