#ifndef WXMARACASIRMVIEWMANAGERDATAMHD_H_
#define WXMARACASIRMVIEWMANAGERDATAMHD_H_


#include "wxMaracasIRMViewManagerData.h"

#include "vtkMetaImageReader.h"
#include "vtkMarchingCubes.h"
#include "vtkCleanPolyData.h"
#include "vtkImageData.h"

class wxMaracasIRMViewManagerDataMhd : public wxMaracasIRMViewManagerData  {

public:
	
	wxMaracasIRMViewManagerDataMhd(vtkImageData* imagedata, std::string dataname="");
	~wxMaracasIRMViewManagerDataMhd();

	
	/**
	**	Adds a prop3D to the world of the application
	**/
	void setVtkImageData(vtkImageData* imagedata);
	
	/**
	**	changes the isovalue in a prop3D
	**/
	void changeIsoValue(double value);	
	/**
	**	Check if the variables are setted correctly
	**/
	void checkInvariant();	
	
	/**
	**	Returns the grey max level of the image
	**/

	int getMaxGreyLevel();

	/**
	**	creates the image 
	**/
	void contourExtractor(int isovalue);		
	
private:	
	
	vtkImageData* _imagedata;
	int _maxgreylevel;

	/**
	** to the image render
	**/
	vtkMarchingCubes* _cubesFilter;
	vtkCleanPolyData* _cleanFilter;	
	vtkPolyDataMapper* _dataMapper;
	
	/**
	** Get's the max grey level of the image
	**/
	int getMaxLevel(vtkImageData* img);
	

	
};

#endif /*WXMARACASIRMVIEWMANAGERDATAMHD_H_*/
