/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasMultipleVolumeRendererManager.h,v $
  Language:  C++
  Date:      $Date: 2009/07/20 10:06:12 $
  Version:   $Revision: 1.3 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/




#ifndef __wxMaracasMultipleVolumeRendererManagerH__
#define __wxMaracasMultipleVolumeRendererManagerH__

#include <iostream>
#include <vector>

#include "wxMaracasMultipleVolumeRendererManagerData.h"


class wxMaracasMultipleVolumeRendererManager  {

public:
	wxMaracasMultipleVolumeRendererManager();
	~wxMaracasMultipleVolumeRendererManager();

	/**
	**	Sets the renderer to manage the prop3D from the view
	**/
	void setRenderer(vtkRenderer*  renderer);
	/**
	**	Adds a volume
	**/
	int addVolume(vtkImageData* img, std::string dataname) throw (char*);	
	
	/**
	**	loads a prop3D from a nSTL file
	**/
	vtkProp3D* getVolume(std::string filename);

	/**
	**	loads a MHD file to convert it into an actor
	**/
	vtkImageData* getImageData(std::string filename);

	/**
	**	adds or removes an actor depending of the bool value
	**/
	void addRemoveActor(int propid, bool addremove) throw(char*);
	/**
	**	Check if the variables are setted correctly
	**/
	void checkInvariant()throw(char*);

	/** 
	** Set Volume Opacity
	**/
	void setVolumeOpacity(int propid, std::vector<double> greylevel,std::vector<double> value) throw(char*);
	/**
	**	Set Volume Color
	**/
	void setVolumeColor(int volid, std::vector<double> greylevel,
									std::vector<double> red,
									std::vector<double> green,
									std::vector<double> blue);	

	/**
	**	Given an id search the data in the vector
	**/
	wxMaracasMultipleVolumeRendererManagerData* getViewData(int id)throw(char*);
	/**
	**
	**/
	void deleteActor(int volumeid)throw (char *);
	
	vtkPiecewiseFunction* GetTransferFunction(int volumeid);
	vtkColorTransferFunction* GetColorFunction(int volumeid);
private:	
	std::vector<wxMaracasMultipleVolumeRendererManagerData*> prop3Dvect;

	vtkRenderer*  _renderer;

	int _idCount;

	

	
};

#endif 
