#include "wxVtk3DBaseView.h"

#include "vtkInteractorStyleBaseView3D.h"


wxVtk3DBaseView::wxVtk3DBaseView(wxWindow *parent)
:wxVtkBaseView( parent )
{
	_configure	= false;
	_aRenderer	= NULL;
	_renWin		= NULL;
	_aCamera	= NULL;
}
//-------------------------------------------------------------------
wxVtk3DBaseView::~wxVtk3DBaseView()
{
	if (_aCamera!=NULL)	{ _aCamera		-> Delete(); }
	if (_aRenderer!=NULL)	{ _aRenderer	-> Delete(); }
	if (_renWin!=NULL)	{ _renWin		-> Delete(); }
}
//-------------------------------------------------------------------
vtkCamera* wxVtk3DBaseView::GetCamera()
{
	return _aCamera;
}
//-------------------------------------------------------------------
vtkRenderer* wxVtk3DBaseView::GetRenderer()  // virtual
{
	return _aRenderer;
}
//-------------------------------------------------------------------
vtkRenderWindow* wxVtk3DBaseView::GetRenWin()  // virtual
{
	return _renWin;
}
//-------------------------------------------------------------------
void wxVtk3DBaseView::Refresh()
{
//	_renWin->Render();
	vtkRenderWindowInteractor *vri = GetWxVTKRenderWindowInteractor();
	vri->vtkRenderWindowInteractor::Render();
}
//-------------------------------------------------------------------
void wxVtk3DBaseView::Configure()
{
	if (_configure==false)
	{
		_configure=true;
		//wxVtkBaseView::Configure();
		_aRenderer	= vtkRenderer::New();
		_renWin		= vtkRenderWindow::New();
		_renWin->AddRenderer(_aRenderer);

		_aRenderer->GradientBackgroundOn();
		_aRenderer->SetBackground( 0.33 , 0.33 , 0.33 );
		_aRenderer->SetBackground2( 0.66 , 0.66 , 0.66 );
		
		
//       _renWin->SetStereoCapableWindow(1);
// //      //renderwindow->SetStereoTypeToCrystalEyes();  
//       _renWin->SetStereoTypeToRedBlue();
//       _renWin->SetStereoRender(1);

		GetWxVTKRenderWindowInteractor()->SetRenderWindow(_renWin);


// EED Borrame
//		vtkInteractorStyle3DMaracas *interactorStyle3DMaracas = vtkInteractorStyle3DMaracas::New(); 
		vtkInteractorStyleBaseView3D *interactorStyleBaseView3D = vtkInteractorStyleBaseView3D::New(); 

		SetInteractorStyleBaseView( interactorStyleBaseView3D );
		interactorStyleBaseView3D->SetInteractor (  GetWxVTKRenderWindowInteractor() );
		GetWxVTKRenderWindowInteractor()->SetInteractorStyle( interactorStyleBaseView3D );
		interactorStyleBaseView3D->SetwxVtkBaseView(this);	


/* EED Borrame
  vtkInteractorStyleSwitch *iss = dynamic_cast<vtkInteractorStyleSwitch*>(_iren->GetInteractorStyle());
  iss->SetCurrentStyleToTrackballCamera();
*/

		// It is convenient to create an initial view of the data. The
		// FocalPoint and Position form a vector direction. Later on
		// (ResetCamera() method) this vector is used to position the camera
		// to look at the data in this direction.
		_aCamera = vtkCamera::New();

//EED 17Avril2009	
/*
		_aCamera->SetViewUp (0, 0, -1);
		_aCamera->SetPosition (0, 1, 0);
 */
		_aCamera->SetViewUp (0, 1, 0);
		_aCamera->SetPosition (0, 0, 1);
		
		_aCamera->SetFocalPoint (0, 0, 0);
		_aCamera->ComputeViewPlaneNormal();

	}
}
//-------------------------------------------------------------------
//EED 27 sep 2006
void wxVtk3DBaseView::GetSpacing(double spc[3])
{
	spc[0]=1;
	spc[1]=1;
	spc[2]=1;
}

