#ifndef WXVTKMPR2DVIEW_H_
#define WXVTKMPR2DVIEW_H_

#include "vtkInteractorStyleMPRView.h"

#include "wxVtk2DBaseView.h"

#include "vtkPolyDataMapper.h"
#include <vtkPolyData.h>
#include <vtkPoints.h>
#include "vtkActor.h"
#include "vtkPolyData.h"

class creaMaracasVisu_EXPORT wxVtkMPR2DView :  public wxVtk2DBaseView
{
public:
	wxVtkMPR2DView( wxWindow *parent, int direction );
	~wxVtkMPR2DView();
	void Configure();
	virtual	void			Refresh();
			vtkMPRBaseData	*GetVtkmprbasedata();
	virtual int				GetActualSlice();
	virtual	void			SetActualSlice(int slice);

			bool			IfMouseTouchX(double x, double y, double z);
			bool			IfMouseTouchY(double x, double y, double z);
			bool			IfMouseTouchZ(double x, double y, double z);
			void			MoveX(double x, double y, double z);
			void			MoveY(double x, double y, double z);
			void			MoveZ(double x, double y, double z);
			void			ChangeAxisColor(double x, double y, double z);
	virtual void			TransFromCoordScreenToWorld(double &X, double &Y, double &Z, bool keepNormalDirection=false, int type=2);
	
			void			SetVisibleAxis(bool ok);


private:

	int							_backX;
	int							_backY;
	int							_backZ;

	bool						_visibleAxis;

	int							_direction;
	vtkPoints					*_ptsA;
	vtkActor					*_lineAActor;
	vtkPolyDataMapper			*_lineAMapper;
    vtkPolyData					*_pdA;
	vtkPoints					*_ptsB;
	vtkActor					*_lineBActor;
	vtkPolyDataMapper			*_lineBMapper;
    vtkPolyData					*_pdB;
//	vtkInteractorStyle2DMaracas	*_interactorStyle2DMaracas; 
	vtkInteractorStyleMPRView	*_interactorstylemprview;
};


#endif /*WXVTKMPR2DVIEW_H_*/
