/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marAxisContours.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:55:07 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#ifndef __MAR__KERNEL__AXIS_CONTOURS__HXX__
#define __MAR__KERNEL__AXIS_CONTOURS__HXX__

#include "marContourVO.h"
#include <vector>

class MAR_KERNEL_EXPORT marAxisContours  
{
public:

	enum ContourTypes
	{
		LUMEN = 0,         /*!< Lumen Type partial. */  
		WALL,              /*!< Wall Type. */ 
		CALCIFICATION,     /*!< Calcification Type. */  
		HYPODENSE,          /*!< Hypodense Type. */
		ELUMEN				/*!< Extracted Lumen */
	};

	void addContour(marContourVO* cont);
	void replaceContour(marContourVO* cont, int index);
	marContourVO* getContour(int i );

	int getTotalPlaques();
	int getContourType(int i);
	int getSize();
	bool isReplaced(int i);

   private:
	   std::vector <marContourVO *> contours;

};

#endif //__MAR__KERNEL__AXIS_CONTOURS__HXX__
 
