/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marContourVO.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:55:07 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#ifndef __MAR__KERNEL__CONTOURVO__HXX__
#define __MAR__KERNEL__CONTOURVO__HXX__

#include "marContour.h"
#include <vtkPolyData.h>
#include <vtkProbeFilter.h>
#include <vtkContourFilter.h>
#include <vtkCleanPolyData.h>
#include <vtkPolyDataConnectivityFilter.h>
#include <vtkStripper.h>

class vtkPoints;
class vtkCellArray;


class MAR_KERNEL_EXPORT  marContourVO 
{

   public:

	   
	   marContour* getContour( );
	   void setContour(marContour* cont);

	   vtkPoints* get3DContour( );
	   void set3DContour(vtkPoints* cont);

	   vtkPolyData* get2DContour( );
	   void set2DContour(vtkPolyData* cont);

	   vtkPoints* get2DDiameterMin( );
	   void set2DDiameterMin(vtkPoints* diam);

	   vtkPoints* get2DDiameterMax( );
	   void set2DDiameterMax(vtkPoints* diam);

	   double getSignal( );
	   void setSignal(double cont);

	   int getType( );
	   void setType(int cont);

	   vtkContourFilter* getIsocontour();
	   void setIsocontour(vtkContourFilter* iso);

	   vtkCleanPolyData* getIsocontourCpd();
	   void setIsocontourCpd(vtkCleanPolyData* isocpd);

	   vtkCleanPolyData* getIsocontourCpd2();
	   void setIsocontourCpd2(vtkCleanPolyData* isocpd);

	   vtkPolyDataConnectivityFilter* getIsocontourDcf();
	   void setIsocontourDcf(vtkPolyDataConnectivityFilter*	isodcf);

	   vtkStripper* getIsocontourStripped();
	   void setIsocontourStripped(vtkStripper* isoStripped);

	   bool isReplaced();
	   void setReplaced(bool rep);

	   ~marContourVO();
		marContourVO();

   private:

	    
	marContour* 		_contours;					//  DATA-MODEL-2D			Axis Contours
	vtkPoints* 			_3Dcontour;					//  VISUALISATION_VTK 3D	Axis perpendicular Contour
	vtkPolyData*		_2Dcontours;				//  VISUALISATION_VTK 2D	Axis perpendicular Contour
	vtkPoints* 			_2DDiameterMin;				//  VISUALISATION_VTK 2D	Line diameter Minimum
	vtkPoints*			_2DDiameterMax;				//  VISUALISATION_VTK 2D	Line diameter Maximum
	double				_signal;					//  Axis intensity signal
	int					_contType;					//  ContourType
	vtkContourFilter*	_isocontour;
	vtkCleanPolyData*	_isocontour_cpd;
	vtkPolyDataConnectivityFilter*	_isocontour_dcf;
	vtkCleanPolyData*	_isocontour_cpd2;
	vtkStripper*		_isocontour_stripped;
	bool				_replaced;

 
}; 
#endif // __MAR__KERNEL__CONTOUR_VO__HXX__

