/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marDynData.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:43 $
  Version:   $Revision: 1.4 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#ifndef __MAR__KERNEL__DYNDATA__HXX__
#define __MAR__KERNEL__DYNDATA__HXX__

#include "marObject.h"
//#include "marAxis.h"
#include "volume.hxx"
#include "marImageData.h"

#include <vtkImageData.h>

class creaMaracasVisu_EXPORT marDynData : public marObject
{
public:

  marDynData( marParameters* p = NULL );
  ~marDynData( ) ;

  void loadData( kVolume* vol, int* voi );

// EED Borrame
//  void loadDataDXMM( kVolume* vol, int* voi );

  float getActualVoxel() { return getParameters()->getVoxelSize( ); }
  kVolume* getVolume( )	{ return( _volume );	};

  //General methods
  void reset( );
  void copyFrom( const marObject& from );

  //Persistence methods
  bool save( std::ofstream& os );
  bool load( std::ifstream& is );

  marImageData* GetMarImageData();


private:

	marImageData	*_marimagedata;
	kVolume			*_volume;
};

#endif // __MAR__KERNEL__DYNDATA__HXX__
